package com.Exception.Doc;

import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Display;

public class DocPlan extends Composite {

	private Composite comp_Plan = null;
	private Composite comp_Write = null;
	private Button plan_Nplan = null;
	private Button plan_Save = null;
	private Combo plan_Font = null;
	private Combo plan_Size = null;
	private Combo plan_fColor = null;
	private Button plan_Boild = null;
	private Button plan_Italic = null;
	private Button plan_U = null;
	private Button plan_left = null;
	private Button plan_Center = null;
	private Button plan_Right = null;
	private Text plan_textArea = null;
	
	public DocPlan(Composite parent, int style) {
		super(parent, style);
		initialize();
	}

	private void initialize() {
        createComp_Plan();
        createComp_Write();
        this.setBounds(new org.eclipse.swt.graphics.Rectangle(0,0,890,515));
	}

	/**
	 * This method initializes comp_Plan	
	 *
	 */
	private void createComp_Plan() {
		comp_Plan = new Composite(this, SWT.BORDER);
		comp_Plan.setBounds(new org.eclipse.swt.graphics.Rectangle(5,3,880,275));
	}

	/**
	 * This method initializes comp_Write	
	 *
	 */
	private void createComp_Write() {
		comp_Write = new Composite(this, SWT.BORDER);
		plan_Nplan = new Button(comp_Write, SWT.NONE);
		comp_Write.setBounds(new org.eclipse.swt.graphics.Rectangle(5,280,880,230));
		plan_Nplan.setBounds(new org.eclipse.swt.graphics.Rectangle(10,10,60,20));
		plan_Nplan.setText(" ");
		plan_Save = new Button(comp_Write, SWT.NONE);
		plan_Save.setBounds(new org.eclipse.swt.graphics.Rectangle(80,10,60,20));
		plan_Save.setText(" ");
		createPlan_Font();
		createPlan_Size();
		createPlan_fColro();
		plan_Boild = new Button(comp_Write, SWT.NONE);
		plan_Boild.setBounds(new org.eclipse.swt.graphics.Rectangle(360,10,20,20));
		plan_Boild.setFont(new Font(Display.getDefault(), "\uad74\ub9bc", 9, SWT.BOLD));
		plan_Boild.setText("B");
		plan_Italic = new Button(comp_Write, SWT.NONE);
		plan_Italic.setBounds(new org.eclipse.swt.graphics.Rectangle(390,10,20,20));
		plan_Italic.setText("/");
		plan_U = new Button(comp_Write, SWT.NONE);
		plan_U.setBounds(new org.eclipse.swt.graphics.Rectangle(420,10,20,20));
		plan_U.setText("U");
		plan_left = new Button(comp_Write, SWT.NONE);
		plan_left.setBounds(new org.eclipse.swt.graphics.Rectangle(450,10,30,20));
		plan_Center = new Button(comp_Write, SWT.NONE);
		plan_Center.setBounds(new org.eclipse.swt.graphics.Rectangle(490,10,30,20));
		plan_Right = new Button(comp_Write, SWT.NONE);
		plan_Right.setBounds(new org.eclipse.swt.graphics.Rectangle(530,10,30,20));
		plan_textArea = new Text(comp_Write, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL | SWT.BORDER);
		plan_textArea.setBounds(new org.eclipse.swt.graphics.Rectangle(0,40,877,188));
	}

	/**
	 * This method initializes plan_Font	
	 *
	 */
	private void createPlan_Font() {
		plan_Font = new Combo(comp_Write, SWT.NONE);
		plan_Font.setText("۲");
		plan_Font.setBounds(new org.eclipse.swt.graphics.Rectangle(150,10,60,20));
	}

	/**
	 * This method initializes plan_Size	
	 *
	 */
	private void createPlan_Size() {
		plan_Size = new Combo(comp_Write, SWT.NONE);
		plan_Size.setText("ũ");
		plan_Size.setBounds(new org.eclipse.swt.graphics.Rectangle(220,10,60,20));
	}

	/**
	 * This method initializes plan_fColro	
	 *
	 */
	private void createPlan_fColro() {
		plan_fColor = new Combo(comp_Write, SWT.NONE);
		plan_fColor.setText("ڻ");
		plan_fColor.setBounds(new org.eclipse.swt.graphics.Rectangle(290,10,60,20));
	}

}
