package com.Exception.main;

import java.awt.Dialog;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.Collection;
import java.util.Vector;

import org.eclipse.swt.events.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.custom.*;


import com.Exception.Doc.*;
import com.Exception.Formation.Formation;
import com.Exception.Formation.*;
import com.Exception.GUIKey.ProtocolKey;
import com.Exception.box.*;
import com.Exception.mail.*;
import com.Exception.note.*;
import com.Exception.remote.remoteControl;
import com.Exception.server.MemElement;
import com.Exception.GUIKey.*;
import com.Exception.Doc.DocPlan;

public class GwMain{

	private Shell shell;
	private static Display display;
	private Menu menuBar, C_con, W_work, S_search, M_mess, U_set, H_help, menu ;
	private CLabel cLabel_Ex01,cLabel_Ex03, cLabel_Ex04, cLabel_Ex05;
	public	Composite comp_main;
	public Composite comp_temp, comp_note, comp_work,  comp_aram, comp_plan;
	private ToolBar toolBar;
	private ToolItem T_sep01, T_home, T_sep02, T_work, T_sep03, T_document, T_sep04;
	private ToolItem T_notes, T_sep05, T_mail, T_sep06, T_search, T_sep07, T_setting;
	private box_doc b_doc = null;
	private box_mail b_mail = null;
	private box_note b_note = null;
	private DocWrite docWrite = null;
	private DocPlan dps = null;
	private ApprDoc a_doc = null;
	private StackLayout stack = null;
	private MenuItem open, exit, Connection, Work, Search, M_message, Userset, Help, H_helpSub, H_info, U_setting= null;
	private MenuItem M_note, M_file, M_mail, S_mem, S_document, W_chat, C_sep10, W_document, W_cash, C_sep04, W_plan;
	private MenuItem C_logout, C_out, C_sep02, C_exit, tray_01;
	private Image image;
	private Tray tray;
	private TrayItem item;
	private remoteControl rc = null;
	private GwSocket gSocket = null;
	private MemElement me = null;
//	private Formation fm = null;
//	private CalenderMain t1 = null;
	

				/**************************************
				*********** GwMain() ************
				***************************************/
	
	public GwMain(remoteControl rc, MemElement me) {
		this.rc = rc;
		this.me = me;
		
		
		display = Display.getDefault();		
		shell = new Shell(SWT.MIN);
		shell.setText("Exception GroupWare");
		shell.setImage(new Image(Display.getCurrent(), getClass().getResourceAsStream("/image/bulb.png")));		
		
		comp_main = new Composite(shell, SWT.BORDER);
		comp_main.setBounds(new org.eclipse.swt.graphics.Rectangle(0,39,893,555));
		
		comp_temp = new Composite(comp_main, SWT.BORDER);
		comp_temp.setBounds(new org.eclipse.swt.graphics.Rectangle(0,0,893,555));
		
		comp_note = new Composite(comp_temp, SWT.BORDER);
		comp_note.setToolTipText("Ʈ");
		comp_note.setBounds(new org.eclipse.swt.graphics.Rectangle(5,5,431,510));
		
		comp_aram = new Composite(comp_temp, SWT.BORDER);
		comp_aram.setToolTipText("˸");
		comp_aram.setBounds(new org.eclipse.swt.graphics.Rectangle(441,5,444,100));
		
//		cLabel_Ex01 = new CLabel(sShell, SWT.COLOR_WHITE | SWT.BORDER);
//		cLabel_Ex01.setImage(new Image(display, getClass().getResourceAsStream("/image/good1.png")));
//		cLabel_Ex01.setBounds(new org.eclipse.swt.graphics.Rectangle(0,560,893,40));
	
		cLabel_Ex03 = new CLabel(comp_aram, SWT.NONE);
		cLabel_Ex03.setToolTipText("");
		cLabel_Ex03.setImage(new Image(display, getClass().getResourceAsStream("/image/notep_aram.png")));
		cLabel_Ex03.setBounds(new org.eclipse.swt.graphics.Rectangle(100,30,40,40));
		
		cLabel_Ex04 = new CLabel(comp_aram, SWT.NONE);
		cLabel_Ex04.setToolTipText("");
		cLabel_Ex04.setImage(new Image(display, getClass().getResourceAsStream("/image/mail_aram.png")));
		cLabel_Ex04.setBounds(new org.eclipse.swt.graphics.Rectangle(200,30,40,40));
		

		cLabel_Ex05 = new CLabel(comp_aram, SWT.NONE);
		cLabel_Ex05.setToolTipText("");
		cLabel_Ex05.setImage(new Image(display, getClass().getResourceAsStream("/image/appr_aram.png")));
		cLabel_Ex05.setBounds(new org.eclipse.swt.graphics.Rectangle(300,30,40,40));
		
		comp_work = new Composite(comp_temp, SWT.BORDER);
		comp_work.setToolTipText("");
		comp_work.setBounds(new org.eclipse.swt.graphics.Rectangle(441,110,444,200));

		
		
		comp_plan = new Composite(comp_temp, SWT.BORDER);
		comp_plan.setToolTipText("");
		comp_plan.setBounds(new org.eclipse.swt.graphics.Rectangle(441,315,444,200));
//		t1 = new CalenderMain(comp_plan, 1);
//		t1.setLayout(new FillLayout());
		comp_plan.layout();
		
		toolBar = new ToolBar(shell, SWT.NONE);
		toolBar.setBounds(new org.eclipse.swt.graphics.Rectangle(0,0,890,40));
		stack = new StackLayout();
		comp_main.setLayout(stack);
		
		
		b_doc = new box_doc(comp_main,1);
		b_note = new box_note(comp_main,2);
		b_mail = new box_mail(comp_main,3);
		docWrite = new DocWrite(comp_main,4);
		dps = new DocPlan(comp_main,5);
		a_doc = new ApprDoc(comp_main, 6);
		
		T_sep01 = new ToolItem(toolBar, SWT.SEPARATOR);
		T_sep01.setWidth(10);
		
		/**************************************
		*********** Tool Bar (Ȩ) ************
		***************************************/

		T_home = new ToolItem(toolBar, SWT.PUSH);
		T_home.setWidth(39);
		T_home.setToolTipText("Ȩ");
		T_home.setImage(new Image(Display.getCurrent(), getClass().getResourceAsStream("/image/home.png")));
		T_home.setEnabled(true);
		
		T_sep02 = new ToolItem(toolBar, SWT.SEPARATOR);
		T_sep02.setWidth(10);
		
					/**************************************
					*********** Tool Bar () ************
					***************************************/
		
		T_work = new ToolItem(toolBar, SWT.PUSH);
		T_work.setImage(new Image(Display.getCurrent(), getClass().getResourceAsStream("/image/doc_write.png")));
		T_work.setToolTipText("");
		T_work.setEnabled(true);
		
		T_sep03 = new ToolItem(toolBar, SWT.SEPARATOR);
		T_sep03.setWidth(10);
		
					/**************************************
					*********** Tool Bar () ************
					***************************************/
		
		T_document = new ToolItem(toolBar, SWT.PUSH);
		T_document.setImage(new Image(Display.getCurrent(), getClass().getResourceAsStream("/image/cash_box.png")));
		T_document.setToolTipText("");
		T_document.setEnabled(true);
		
		T_sep04 = new ToolItem(toolBar, SWT.SEPARATOR);
		T_sep04.setWidth(10);
					
					/**************************************
					*********** Tool Bar () ************
					***************************************/

		
		T_notes = new ToolItem(toolBar, SWT.PUSH);
		T_notes.setImage(new Image(Display.getCurrent(), getClass().getResourceAsStream("/image/note_box.png")));
		T_notes.setToolTipText("");
		T_notes.setEnabled(true);
		
		T_sep05 = new ToolItem(toolBar, SWT.SEPARATOR);
		T_sep05.setWidth(10);
		
					/**************************************
					*********** Tool Bar () ************
					***************************************/
		
		T_mail = new ToolItem(toolBar, SWT.PUSH);
		T_mail.setImage(new Image(Display.getCurrent(), getClass().getResourceAsStream("/image/mail_box.png")));
		T_mail.setToolTipText("");
		T_mail.setEnabled(true);
		
		T_sep06 = new ToolItem(toolBar, SWT.SEPARATOR);
		T_sep06.setWidth(10);
		
					/**************************************
					*********** Tool Bar (˻) ************
					***************************************/
		
		T_search = new ToolItem(toolBar, SWT.PUSH);
		T_search.setImage(new Image(Display.getCurrent(), getClass().getResourceAsStream("/image/serch.png")));
		T_search.setToolTipText("˻");
		T_search.setEnabled(true);
		
		
		T_sep07 = new ToolItem(toolBar, SWT.SEPARATOR);
		T_sep07.setWidth(10);
		
					/**************************************
					*********** Tool Bar () ************
					***************************************/
		
		T_setting = new ToolItem(toolBar, SWT.PUSH);
		T_setting.setImage(new Image(Display.getCurrent(), getClass().getResourceAsStream("/image/confg.png")));
		T_setting.setToolTipText("");
		T_setting.setEnabled(true);
		
		
		/**************************************
		*********** Menu Bar ************
		***************************************/
		
		menuBar = new Menu(shell, SWT.BAR);
		
		Connection = new MenuItem(menuBar, SWT.CASCADE);
		Connection.setText("");
		
		Work = new MenuItem(menuBar, SWT.CASCADE);
		Work.setText("");
		
		
		Search = new MenuItem(menuBar, SWT.CASCADE);
		Search.setText("˻");
				
		M_message = new MenuItem(menuBar, SWT.CASCADE);
		M_message.setText("޽");
		
		Userset = new MenuItem(menuBar, SWT.CASCADE);
		Userset.setText("");
		
		Help = new MenuItem(menuBar, SWT.CASCADE);
		Help.setText("");
		
		H_help = new Menu(Help);
		
		H_helpSub = new MenuItem(H_help, SWT.PUSH);
		H_helpSub.setText(" ׸");
		
		H_info = new MenuItem(H_help, SWT.PUSH);
		H_info.setText("");
		Help.setMenu(H_help);
		
		U_set = new Menu(Userset);
		
		U_setting = new MenuItem(U_set, SWT.PUSH);
		U_setting.setText("ȯ漳");
		
		Userset.setMenu(U_set);
		
		M_mess = new Menu(M_message);
		
		M_note = new MenuItem(M_mess, SWT.PUSH);
		M_note.setText("");
		
		M_file = new MenuItem(M_mess, SWT.PUSH);
		M_file.setText("Ϻ");
		
		M_mail = new MenuItem(M_mess, SWT.PUSH);
		M_mail.setText("Ϻ");
		
		M_message.setMenu(M_mess);
		
		S_search = new Menu(Search);
		
		S_mem = new MenuItem(S_search, SWT.PUSH);
		S_mem.setText("˻");

		
		S_document = new MenuItem(S_search, SWT.PUSH);
		S_document.setText("˻");
		
		Search.setMenu(S_search);
		
		
		W_work = new Menu(Work);
		
		W_chat = new MenuItem(W_work, SWT.PUSH);
		W_chat.setText("ȭȸ");
		
		C_sep10 = new MenuItem(W_work, SWT.SEPARATOR);
		
		W_document = new MenuItem(W_work, SWT.PUSH);
		W_document.setText("ۼ");
				
		W_cash = new MenuItem(W_work, SWT.PUSH);
		W_cash.setText("ڰ");

		
		C_sep04 = new MenuItem(W_work, SWT.SEPARATOR);
		
		W_plan = new MenuItem(W_work, SWT.PUSH);
		W_plan.setText("");
		
		Work.setMenu(W_work);
				
		C_con = new Menu(Connection);		
		
				/**************************************
				*********** Menu Bar(α׾ƿ)************
				***************************************/
		
		C_logout = new MenuItem(C_con, SWT.PUSH);
		C_logout.setText("α׾ƿ");
		
		
				/**************************************
				*********** Menu Bar(ϱ)************
				***************************************/
		
		C_out = new MenuItem(C_con, SWT.PUSH);
		C_out.setText("ϱ");
				
						
		C_sep02 = new MenuItem(C_con, SWT.SEPARATOR);
		
				/**************************************
				*********** Menu Bar(ݱ)************
				***************************************/
		
		C_exit = new MenuItem(C_con, SWT.PUSH);
		C_exit.setText("ݱ");
		
				
		    /**************************************
			*************** Tray Icon***************
			***************************************/
	
	image = new Image(display, "./image/bulb.png");
	tray = display.getSystemTray();
	if (tray == null) {
		System.out.println("The system tray is not available");
	} else {
		item = new TrayItem(tray, SWT.NONE);
		item.setToolTipText("SWT TrayItem");

		menu = new Menu(shell, SWT.POP_UP);
		
		open = new MenuItem(menu, SWT.Selection);
		open.setText("");
		open.setEnabled(false);
		
		tray_01 = new MenuItem(menu, SWT.SEPARATOR);

		exit = new MenuItem(menu, SWT.Selection);
		exit.setText("");
		exit.setEnabled(false);

		item.setImage(image);

	}
		
		    cLabel_Ex03.addListener(SWT.MouseDoubleClick, getListener());
		    cLabel_Ex04.addListener(SWT.MouseDoubleClick, getListener());
		    cLabel_Ex05.addListener(SWT.MouseDoubleClick, getListener());
		    T_home.addListener(SWT.Selection, getListener());
		    T_work.addListener(SWT.Selection, getListener());
		    T_document.addListener(SWT.Selection, getListener());
		    T_notes.addListener(SWT.Selection, getListener());
		    T_mail.addListener(SWT.Selection, getListener());
		    T_search.addListener(SWT.Selection, getListener());
		    T_setting.addListener(SWT.Selection, getListener());
		    M_note.addListener(SWT.Selection, getListener());
		    M_file.addListener(SWT.Selection, getListener());
		    M_mail.addListener(SWT.Selection, getListener());
		    W_document.addListener(SWT.Selection, getListener());
		    W_cash.addListener(SWT.Selection, getListener());
		    W_plan.addListener(SWT.Selection, getListener());
		    C_logout.addListener(SWT.Selection, getListener());
		    open.addListener(SWT.Selection, getListener());
		    exit.addListener(SWT.Selection, getListener());
		    item.addListener(SWT.MenuDetect, getListener());
		    shell.addListener(SWT.CLOSE, getListener());
		    
		Connection.setMenu(C_con);		
		shell.setMenuBar(menuBar);
		shell.setMinimumSize(900,650);
		shell.setSize(900,650);
		
	}
	
				 /**************************************
				*************** Listener***************
				***************************************/
	
	public Listener getListener(){
		Listener listener = new Listener() {
			public void handleEvent(Event e) {
				Object obj = e.widget;
				gSocket = GwSocket.getGwSocket();
				if (obj == shell) {
					shell.setVisible(false);					
					while (!shell.isDisposed()) {
						if (!display.readAndDispatch())
							display.sleep();
					}
				}else if (obj == cLabel_Ex03) {
					System.out.println("");
					stack.topControl= b_note;
					comp_main.layout();
				}else if (obj == cLabel_Ex04) {
					System.out.println("");
					stack.topControl= b_doc;
					comp_main.layout();
				}else if (obj == cLabel_Ex05) {
					System.out.println("");
					stack.topControl= a_doc;
					comp_main.layout();
				}else if (obj == T_home) {
					System.out.println("Ȩ");
					stack.topControl= comp_temp;
					comp_main.layout();
				}else if (obj == T_work) {
					System.out.println("");
					stack.topControl = a_doc;
					comp_main.layout();
				}else if (obj == T_document) {
					System.out.println("");
					stack.topControl = b_doc;
					comp_main.layout();
				}else if (obj == T_notes) {
					System.out.println("");
					stack.topControl = b_note;
					comp_main.layout();
				}else if (obj == T_mail) {
					System.out.println("");
					stack.topControl = b_mail;
					comp_main.layout();
				}else if (obj ==T_search) {
					System.out.println("˻");
				}else if (obj == T_setting) {
					System.out.println("");
				}else if (obj == M_note) {
					System.out.println(""); 
					note_Send n_send = new note_Send();
					n_send.sShell.open();
				}else if (obj == M_file) {
					System.out.println("Ϻ"); 
					note_FileSend n_fileSend = new note_FileSend();
					n_fileSend.createSShell();
					n_fileSend.sShell.open();
				}else if (obj == M_mail) {
					System.out.println("Ϻ"); 
					mail_send m_send = new mail_send();
					m_send.createSShell();
					m_send.sShell.open();
				}else if (obj == W_document) {
					System.out.println("ۼ");
					stack.topControl= docWrite;
					comp_main.layout();
				}else if (obj == W_cash) {
					System.out.println("ڰ");
					stack.topControl= a_doc;
					comp_main.layout();
				}else if (obj == W_plan) {
					System.out.println("");
					stack.topControl = dps;
					comp_main.layout();
				}else if (obj == C_logout) {
					System.out.println("α׾ƿ ");
					Collection v = new Vector();
					try {
						v.add(new Integer(ProtocolKey.logout));
						v.add(me.getEmp_id());
						gSocket.getOos().writeObject(v);
						gSocket.getOos().flush();
					} catch (Exception e1) { 
						System.out.println("C_logout :"+e1);
					}
				}else if (obj == C_out) {
					System.out.println("ϱ");
					Collection v1 = new Vector();
					MessageBox m_out = new MessageBox(shell, SWT.OK | SWT.CANCEL);
					m_out.setText(" ϱ");
					m_out.setMessage(" Ͻðڽϱ?");
					try {
						if(m_out.open() == SWT.OK) {
							try {
								v1.add(new Integer(ProtocolKey.out));
								v1.add(me.getEmp_id());
								gSocket.getOos().writeObject(v1);
								gSocket.getOos().flush();

								Vector out = (Vector)gSocket.getOis().readObject();				
								Integer receve = (Integer)out.get(0);
								
								switch (receve.intValue()) {
								case ProtocolKey.outOk:
									MessageBox m_outOk = new MessageBox(shell, SWT.OK);
									m_outOk.setText(" Ȯ");
									m_outOk.setMessage("ó Ǿϴ.");
									try {
										if(m_outOk.open() == SWT.OK){}
									} catch (Exception e1) {}
									break;

								case ProtocolKey.outFail:
									MessageBox m_outfail = new MessageBox(shell, SWT.OK);
									m_outfail.setText(" Ȯ");
									m_outfail.setMessage("ó  ʾҽϴ.");
									try {
										if(m_outfail.open() == SWT.OK){}
									} catch (Exception e1) {}
									break;
								}
							} catch (Exception e1) {
							
							}
							
						}
					}catch(Exception error) {
						System.out.println("C_out : "+error);
					}
				}else if (obj == C_exit) {
					System.out.println("ݱ");
					getShell().setVisible(false);
				}else if (obj == open) {
					System.out.println("");
					shell.setVisible(true);
				}else if (obj == exit) {
					System.out.println("");
					Collection v = new Vector();
					try {
						v.add(new Integer(ProtocolKey.logout));
						v.add(me.getEmp_id());
						gSocket.getOos().writeObject(v);
						gSocket.getOos().flush();
						gSocket.getOos().close();
						
					
					} catch (Exception e1) {
						
					}finally {
						System.exit(0);
					}
				}else if (obj == item) {
					menu.setVisible(true);
				}
				
		    	  
		      }
		    };
		return listener; 
	}
	
	/**************************************
	*********** Main ************
	***************************************/

	/*public static void main(String[] args) {
		
		GwMain gwMain = new GwMain(gSocket, me);

		
		gwMain.shell.setVisible(false);
		while (!gwMain.shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}*/
	
	
	public Composite getComp_main() {
		return comp_main;
	}

	public void setComp_main(Composite comp_main) {
		this.comp_main = comp_main;
	}

	public MenuItem getExit() {
		return exit;
	}

	public void setExit(MenuItem exit) {
		this.exit = exit;
	}

	public MenuItem getOpen() {
		return open;
	}

	public void setOpen(MenuItem open) {
		this.open = open;
	}

	public Shell getShell() {
		return shell;
	}

	public void setShell(Shell shell) {
		this.shell = shell;
	}

	public Composite getComp_note() {
		return comp_note;
	}

	public void setComp_note(Composite comp_note) {
		this.comp_note = comp_note;
	}

	
	
}
