package com.Exception.server;

import java.util.Date;
import java.util.Properties;

import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.activation.FileDataSource;
import javax.mail.BodyPart;
import javax.mail.Message;
import javax.mail.Multipart;
import javax.mail.SendFailedException;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.AddressException;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;
import javax.mail.internet.MimeUtility;

public class MailSend {
	public int mailSend 
	(String from, String to ,String subject,
			String content,String filename) {
		int i=0;
		String host = "58.227.54.250";

		try {
			
			Properties props = System.getProperties();

			props.put("mail.smtp.host", host);
			Session session = Session.getInstance(props, null);
			Message message = new MimeMessage(session);
			
			message.setFrom(new InternetAddress(from));
			message.addRecipient(Message.RecipientType.TO, new InternetAddress(to));
			message.setSubject(subject);
			message.setSentDate(new Date());

			if(filename==null||filename.equals("")){
				message.setText(content);
			}else{

				BodyPart messageBodyPart = new MimeBodyPart();

				messageBodyPart.setText(content);

				Multipart multipart = new MimeMultipart();

				multipart.addBodyPart(messageBodyPart);

				messageBodyPart = new MimeBodyPart();

				DataSource source = new FileDataSource(filename);
				messageBodyPart.setDataHandler(new DataHandler(source));
				
				String tempName = 
					MimeUtility.encodeText
					(source.getName(), "KSC5601", "Q");
				messageBodyPart.setFileName(tempName);
				messageBodyPart.setFileName(source.getName());

				multipart.addBodyPart(messageBodyPart);
				message.setContent(multipart);
			}
			Transport.send(message);
			
		}catch (AddressException e) {
			e.printStackTrace();
			i=1;
		}catch (SendFailedException e) {
			e.printStackTrace();
			i=2;
		}catch(Exception e) {
			e.printStackTrace();
		}finally{
			return i;
		}
	}
}
