package com.itbc.lucene;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList; 

import com.itbc.dbCon.*; 
import com.itbc.Element.*;
public class LuceneManager {
	private DbConnection dbConn;
	public LuceneManager(){
		dbConn = new DbConnection();	
	}

	
	 
	// ü Ʈ
	public ArrayList getallList(int num)throws Exception{
		
		Connection conn = null;
		PreparedStatement pstmt = null;
		ArrayList list=new ArrayList();
		ResultSet rs = null;
		String sql= null;
		int numtemp = num*1000;
		
		//String sch = "SELECT top "+numtemp+" seq FROM board";
		sql = "SELECT  notice_seq,notice_title,notice_content,notice_division,notice_date" +
				" FROM notice notice_seq limit 1000 offset "+numtemp;

		try{

			conn = dbConn.getConnection();		
			pstmt = conn.prepareStatement(sql);
			rs=pstmt.executeQuery();

			while(rs.next()){
//				System.out.println("rs.next = "+numtemp);
				NoticeElement be = new NoticeElement();
				be.setNotice_seq(rs.getInt("notice_seq"));
				be.setNotice_title(rs.getString("notice_title"));
				be.setNotice_content(rs.getString("notice_content"));
				be.setNotice_division(rs.getString("notice_division"));
				be.setNotice_date(rs.getString("notice_date"));
				list.add(be);
//				numtemp++;
			} 
							
		}catch(Exception e){
			throw e;
		}finally{
	
			if(rs!=null) 
				rs.close();

			if(pstmt!=null) 
				pstmt.close();

			if(conn!=null)
				conn.close();
			 
		}
		return list;
	}
	 
	//˻
	public ArrayList getWordList()throws Exception{
		
		Connection conn = null;
		PreparedStatement pstmt = null;
		ArrayList list=new ArrayList();
		ResultSet rs = null;
		String sql= null;
		sql=	"select query from searchword order by count desc limit 5";
		try{
			conn = dbConn.getConnection();//DBConn.getConnection();			
			pstmt = conn.prepareStatement(sql);
			rs=pstmt.executeQuery();

			while(rs.next()){
				LuceneElement bean = new  LuceneElement();
				bean.setS_query(rs.getString("query"));		//˻
				list.add(bean);
			} 
							
		}catch(Exception e){
			throw e;
		}finally{
	
			if(rs!=null) 
				rs.close();

			if(pstmt!=null) 
				pstmt.close();

			if(conn!=null)
				conn.close();
			 
		}
		return list;
	}
	
	
	public String queryinsert(String query){
		 
		Connection conn = null;
		PreparedStatement pstmt = null;
		String re="";
		String sql="";
		int temp=0;
		ResultSet rs = null;
		
		try{
			sql = "select count from searchword where query=?";
			conn = dbConn.getConnection();//DBConn.getConnection();	
			pstmt = conn.prepareStatement(sql);
			pstmt.setString(1,query);
			rs = pstmt.executeQuery();		
			
			if(rs.next()){
				temp = rs.getInt("count")+1;
				
					sql = "update searchword set count=? where query=?";
					pstmt = conn.prepareStatement(sql);
					pstmt.setInt(1,temp);
					pstmt.setString(2,query);
					pstmt.executeUpdate();

		
			}else{
				temp=1;
					sql = "insert into searchword (query, count) values(?,?)";
					pstmt = conn.prepareStatement(sql);
					pstmt.setString(1,query);
					pstmt.setInt(2,temp);
					pstmt.executeUpdate();

		
			}
			
		}catch(Exception e){
			e.printStackTrace();
			re = e.getMessage();
		}finally{
			try{
				if(pstmt!=null) 
					pstmt.close();

				if(rs!=null) 
					rs.close();

				if(conn!=null)
					conn.close();
			}catch(Exception e){
				e.printStackTrace();
			}
		}
		return re;

	}
 
}

