package com.Exception.Formation;
import java.awt.MenuItem;
import java.awt.event.MouseAdapter;
import java.util.*;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.swt.widgets.Widget;

import com.Exception.note.note_Send;
import com.Exception.server.*;

public class Formation {
	public Shell shell;
	private Tree tree;
	private TreeItem[] item;
	private TreeItem person;
	private String[] name;
	private Vector recive, ins;
	private ArrayList allMember;
	private String allName,allId;
	public static HashMap hm = null;
	private String temp;
	private note_Send nSend = null;	
	
	public Formation(note_Send nSend){
		
		this.nSend = nSend;
		FormateElement fe = FormateElement.getFormateElement();
		
		shell= new Shell();
		shell.setLayout(new FillLayout());
		tree = new Tree(shell, SWT.BORDER);
		tree.setLayoutData(new GridData(GridData.FILL_BOTH));
		
		recive = fe.getDiv();
		ins = (Vector)recive.get(2);
		
		int vlength = ins.size();
		
		allMember = (ArrayList)recive.get(3);
		int allLen = allMember.size();		
		item = new TreeItem[vlength];
		
		for(int i=0; i<vlength;i++){
			item[i] = new TreeItem(tree, SWT.NULL);
			item[i].setText((String) ins.get(i));
		}

		hm = new HashMap();
		
		for(int i=0; i<vlength; i++){
			for(int j=0; j<allLen; j++){
				
				allName = (((MemElement)allMember.get(j)).getEmp_name());
				allId = (((MemElement)allMember.get(j)).getEmp_id());
				hm.put(allName,allId);
				if(item[i].getText().equals(((MemElement)allMember.get(j)).getEmp_division())){
					person = new TreeItem(item[i], SWT.NULL);
					person.setText(allName);
				}
			}
		}
		
		

		
		tree.addListener(SWT.MouseDoubleClick, getListener());
		
		shell.setSize(300,500);
		
	}
		public Listener getListener(){
			
			Listener listener = new Listener(){				
				public void handleEvent(Event e){
					String str = "";
					TreeItem[] select = tree.getSelection();
					
					for(int i=0; i<select.length;i++){
						str+=select[i]+" ";
					}
					
					String str1 = str.substring(10);
					String[] str2 = str1.split("}");
					str=str2[0];
					Collection c =hm.keySet();
					Iterator it = c.iterator();
					temp = (String) hm.get(str);
					if (temp != null) {
						nSend.reciver_text.setText(temp);
						shell.setVisible(false);	
					}
					


				}
					
							
				
			};
			
			return listener;
			
		}
		public static HashMap getHm() {
			return hm;
		}
		public static void setHm(HashMap hm) {
			Formation.hm = hm;
		}
		public String getAllId() {
			return allId;
		}
		public void setAllId(String allId) {
			this.allId = allId;
		}
		public ArrayList getAllMember() {
			return allMember;
		}
		public void setAllMember(ArrayList allMember) {
			this.allMember = allMember;
		}
		public String getAllName() {
			return allName;
		}
		public void setAllName(String allName) {
			this.allName = allName;
		}
		public Vector getIns() {
			return ins;
		}
		public void setIns(Vector ins) {
			this.ins = ins;
		}
		public TreeItem[] getItem() {
			return item;
		}
		public void setItem(TreeItem[] item) {
			this.item = item;
		}
		public String[] getName() {
			return name;
		}
		public void setName(String[] name) {
			this.name = name;
		}
		public TreeItem getPerson() {
			return person;
		}
		public void setPerson(TreeItem person) {
			this.person = person;
		}
		public Vector getRecive() {
			return recive;
		}
		public void setRecive(Vector recive) {
			this.recive = recive;
		}
		public Shell getShell() {
			return shell;
		}
		public void setShell(Shell shell) {
			this.shell = shell;
		}
		public String getTemp() {
			return temp;
		}
		public void setTemp(String temp) {
			this.temp = temp;
		}
		public Tree getTree() {
			return tree;
		}
		public void setTree(Tree tree) {
			this.tree = tree;
		}
	
	
	
}
