package com.Exception.GUI;
	
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StackLayout;
import org.eclipse.swt.events.HelpEvent;
import org.eclipse.swt.events.HelpListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;



public class MainUserInterface {

	public Shell muiShell;
	private Display display;
	private ToolBar toolbar;
	private ToolItem tool_connect,tool_setting,tool_reload,tool_exit,tool_help;
	private MenuItem connect,configure,newEmp,empUp,empSel,login_state,
		commute_state,setPort,server,emp,state,setDir,doc_form,selCut,
		doc_save,end,allCut,serverCut,exit,help,helpM,appInfo;
	private Menu menuBar,s_connect,s_emp,s_state,s_configure,s_setDir,s_end,s_help;
	private ContentComposite con_comp;
	
	
	
	private HelpListener help_listener = new HelpListener(){
		public void helpRequested(HelpEvent he) {
			System.out.println(he.widget);
			System.out.println("asdfasdfasddfssda");
		}
		
	};
	public static void main(String[] args) {
		new MainUserInterface();
	}
	public MainUserInterface(){
		display = Display.getDefault();
		muiShell = new Shell();
		
		muiShell.setText("Exception GroupWare Server User Interface");
		muiShell.setBounds(200,200,900,650);
		menuInit();
		toolbarInit();
		this.display = display;
		con_comp= new ContentComposite(muiShell);
		//tool_listener = new ToolbarListener(con_comp,display);
		//menu_listener = new Menu_Listener(con_comp,display);
		
		listenerInit();
		doLayout();
		muiShell.open();
		muiShell.addListener (SWT.Close, new Listener () {
			public void handleEvent (Event event) {
				MessageBox messageBox = new MessageBox (muiShell, SWT.APPLICATION_MODAL | SWT.YES | SWT.NO);
				messageBox.setText ("Exiting Application");
				messageBox.setMessage ("Do you really want to exit?");
				if(messageBox.open() == SWT.YES){
				/*	if(menu_listener.getT()!=null){
						menu_listener.getT().interrupt();
					}
					if(tool_listener.getT()!=null){
						tool_listener.getT().interrupt();
					}*/
					event.doit = true;
				}
			}
		});
		while (!muiShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}
	
	// ̾ƿ
	private void doLayout(){
		GridLayout grid = new GridLayout();
		grid.numColumns =3;
		muiShell.setLayout(grid);
		
		GridData data = new GridData();
		data.horizontalSpan = 3;
		toolbar.setLayoutData(data);
		
		data = new GridData();
		data.horizontalAlignment = GridData.FILL;
		data.verticalAlignment = GridData.FILL;
		data.grabExcessHorizontalSpace = true;
		data.grabExcessVerticalSpace = true;
		data.horizontalSpan = 3;
		con_comp.setLayoutData(data);
	}
	/**#######################################################################
	 * 								Toolbar
	 * #######################################################################
	 */
	private void toolbarInit(){
		toolbar = new ToolBar(muiShell, SWT.NONE);
		
		tool_connect = new ToolItem(toolbar,SWT.PUSH);
		tool_connect.setToolTipText("");
		tool_connect.setImage(new Image(Display.getCurrent(),getClass().getResourceAsStream("/img/connect.png")));
		tool_connect.setText("connect");
		
		tool_setting = new ToolItem(toolbar,SWT.PUSH);
		tool_setting.setImage(new Image(Display.getCurrent(),getClass().getResourceAsStream("/img/setting.png")));
		tool_setting.setToolTipText("");
		tool_setting.setText("config");
		
		tool_reload = new ToolItem(toolbar,SWT.PUSH);
		tool_reload.setImage(new Image(Display.getCurrent(),getClass().getResourceAsStream("/img/reload.png")));
		tool_reload.setToolTipText("õ");
		tool_reload.setText("reload");
		
		tool_exit = new ToolItem(toolbar,SWT.PUSH);
		tool_exit.setImage(new Image(Display.getCurrent(),getClass().getResourceAsStream("/img/exit.png")));
		tool_exit.setToolTipText("α׷ ");
		tool_exit.setText("exit");
		
		tool_help = new ToolItem(toolbar,SWT.PUSH);
		tool_help.setImage(new Image(Display.getCurrent(),getClass().getResourceAsStream("/img/help.png")));
		tool_help.setToolTipText("");
		tool_help.setText("help");
	}
	
	/**#######################################################################
	 * 								Menu
	 * #######################################################################
	 */
	private void menuInit(){
		//޴ 
		menuBar = new Menu(muiShell,SWT.BAR);
		
		//  ޴(server Menu)
		server = new MenuItem(menuBar,SWT.CASCADE);
		//޴ۻ (  ΰ?,Ÿ)
		server.setText("(&G)");
		s_connect = new Menu(server);
		// ޴  ٽ ޴ ( ޴ ޴ΰ )
		server.setMenu(s_connect);
		//
		connect = new MenuItem(s_connect, SWT.PUSH);
		connect.setText("(&T)");
	
		//   ޴(Employee Menu)
		emp = new MenuItem(menuBar,SWT.CASCADE);
		emp.setText("(&E)");
		s_emp = new Menu(emp);
		emp.setMenu(s_emp);
		newEmp = new MenuItem(s_emp, SWT.PUSH);
		newEmp.setText("űԻ(&N)");
		empUp = new MenuItem(s_emp, SWT.PUSH);
		empUp.setText("(&R)");
		empSel = new MenuItem(s_emp, SWT.PUSH);
		empSel.setText("˻(&S)");
		
		// Ȳ  ޴(server status menu)
		state = new MenuItem(menuBar,SWT.CASCADE);
		state.setText("Ȳ(&I)");
		s_state = new Menu(state);
		state.setMenu(s_state);
		login_state = new MenuItem(s_state, SWT.PUSH);
		login_state.setText("Ȳ(&W)");
		commute_state = new MenuItem(s_state, SWT.PUSH);
		commute_state.setText("Ȳ(&M)");

		//   ޴(server setting menu)
		configure = new MenuItem(menuBar,SWT.CASCADE);
		configure.setText("(&F)");
		s_configure = new Menu(configure);
		configure.setMenu(s_configure);
		setPort = new MenuItem(s_configure, SWT.PUSH);
		setPort.setText("Ʈ(&P)");
		setDir = new MenuItem(s_configure, SWT.CASCADE);
		setDir.setText("丮(&D)");
		s_setDir = new Menu(setDir);
		setDir.setMenu(s_setDir);
		doc_form = new MenuItem(s_setDir, SWT.PUSH);
		doc_form.setText(" dir(&O)");
		doc_save = new MenuItem(s_setDir, SWT.PUSH);
		doc_save.setText("幮 dir(&A)");

		//  ޴(exit Menu)
		end = new MenuItem(menuBar,SWT.CASCADE);
		end.setText("(&U)");
		s_end = new Menu(end);
		end.setMenu(s_end);
		allCut = new MenuItem(s_end, SWT.PUSH);
		allCut.setText("(&X)");
		selCut = new MenuItem(s_end, SWT.PUSH);
		selCut.setText("ڼ(&B)");
		serverCut = new MenuItem(s_end, SWT.PUSH);
		serverCut.setText("(&Q)");
		exit = new MenuItem(s_end, SWT.PUSH);
		exit.setText("α׷(&C)");
		
		//  ޴(help menu)
		help = new MenuItem(menuBar,SWT.CASCADE);
		help.setText("(&H)");
		s_help = new Menu(help);
		help.setMenu(s_help);
		helpM = new MenuItem(s_help, SWT.PUSH);
		helpM.setText(" (F1)");
		new MenuItem(s_help, SWT.SEPARATOR);
		appInfo = new MenuItem(s_help, SWT.PUSH);
		appInfo.setText("α׷ (&L)");
		//޴ 
		
		muiShell.setMenuBar(menuBar);
	}
	
	/**#######################################################################
	 * 						  
	 * #######################################################################
	 */

	private void listenerInit(){

		Listener tool_listener = new Listener(){
			public void handleEvent(Event e){
				Widget widget = e.widget;
				
				if(widget==tool_connect){
					System.out.println(widget);
				}else if(widget==tool_setting){
					System.out.println(widget);
				}else if(widget==tool_reload){
					System.out.println(widget);
				}else if(widget==tool_exit){
					System.out.println(widget);
				}else if(widget==tool_help){
					System.out.println(widget);
				}
				
				if(e.type == SWT.HELP){
					System.out.println("help ok!!!");
				}
			}
		};
		
		Listener menu_listener = new Listener(){
			public void handleEvent(Event e){
				System.out.println(e.widget.toString());
				if(e.widget!=helpM){
				String [] str = e.widget.toString().split("&");
					String s = str[1].substring(0,1);
					char c = s.charAt(0);
					System.out.println(c);
					System.out.println(s);
			
					switch (c) {
					
					case 'T':// 
						//Server sss = new Server(cc,display);
						//display.asyncExec(sss);
						//t.start();
						System.out.println(" !!!");
						break;
			
					case 'N'://űԻ
						System.out.println(" űԻ!!!");
						break;
			
					case 'R'://
						System.out.println(" !!!");
						break;
			
					case 'S'://˻
						System.out.println(" ˻!!!");
						break;
			
					case 'W'://Ȳ 
						System.out.println(" Ȳ!!!");
						break;
			
					case 'M'://Ȳ
						System.out.println(" Ȳ!!!");
						break;
			
					case 'P':
				
						break;
			
					case 'O':
				
						break;
						
					case 'A':
						
						break;
						
					case 'X':
						
						break;
						
					case 'B':
						
						break;
						
					case 'Q':
						
						break;
						
					case 'C':
						
						
					case 'L':
						
						break;
						
					}
				}else{
					//
					System.out.println(e.widget);
				}
			}
		};
		//toolbar add listener
		tool_connect.addListener(SWT.Selection,tool_listener);
		tool_setting.addListener(SWT.Selection,tool_listener);
		tool_reload.addListener(SWT.Selection,tool_listener);
		tool_exit.addListener(SWT.Selection,tool_listener);
		tool_help.addListener(SWT.Selection,tool_listener);
		//menu add listener 
		connect.addListener(SWT.Selection,menu_listener);
		newEmp.addListener(SWT.Selection,menu_listener);
		empUp.addListener(SWT.Selection,menu_listener);
		empSel.addListener(SWT.Selection,menu_listener);
		login_state.addListener(SWT.Selection,menu_listener);
		commute_state.addListener(SWT.Selection,menu_listener);
		setPort.addListener(SWT.Selection,menu_listener);
		doc_form.addListener(SWT.Selection,menu_listener);
		doc_save.addListener(SWT.Selection,menu_listener);
		allCut.addListener(SWT.Selection,menu_listener);
		selCut.addListener(SWT.Selection,menu_listener);
		serverCut.addListener(SWT.Selection,menu_listener);
		exit.addListener(SWT.Selection,menu_listener);
		appInfo.addListener(SWT.Selection,menu_listener);
		helpM.addListener(SWT.Selection,menu_listener);
	}	
}
