package com.Exception.cl;

import java.io.*;
import java.net.InetSocketAddress;
import java.net.ServerSocket;
import java.nio.ByteBuffer;
import java.nio.channels.ClosedChannelException;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;
import java.util.Iterator;
import java.util.Vector;
import java.util.logging.*;
import com.Exception.GUI.*;

public class GroupServer {
	private Selector selector;
	private ServerSocketChannel ssc= null;
	private ServerSocket socket= null;
	private Vector v = new Vector();
	private MainUserInterface mui = null;
	public void initServer(){
		try{
			// 
			selector = Selector.open();
			//    
			ssc = ServerSocketChannel.open();
			//ŷ 
			ssc.configureBlocking(false);
			socket = ssc.socket();

			//־ ĶͿ شϴ ּҴ. Ʈ  ε Ѵ.
			InetSocketAddress iAddr = new InetSocketAddress("localhost",9090);
			socket.bind(iAddr);
			// ä Ϳ Ѵ.
			ssc.register(selector,SelectionKey.OP_ACCEPT);
		}catch (Exception e) {
			System.out.println("   !!!"+e);
		}
	}
	
	public void startServer(){
	
		info("Server is started");
		try {
			while(true){				
				selector.select();
				
				Iterator it = selector.selectedKeys().iterator();
				while(it.hasNext()){
					SelectionKey key = (SelectionKey)it.next();
					if(key.isAcceptable()){
						System.out.println(key);
						//  äο Ŭ̾Ʈ  
						accept(key);
					}else if(key.isReadable()){
						//̹  Ŭ̾Ʈ ޽ 
						System.out.println(key);
						read(key);
					}
					//̹ ó ̺Ʈ̹Ƿ ݵ  
					it.remove();
				}
			
			}
		} catch (Exception e) {
			System.out.println("  !!!"+e);
		}
	}
	
	private void accept(SelectionKey key){
		ServerSocketChannel server = (ServerSocketChannel)key.channel();
		SocketChannel sc = null;
		try {
			sc = server.accept();
			registerChannel(selector,sc,SelectionKey.OP_READ);
			info(sc.toString()+" Ŭ̾Ʈ ߽ϴ.");
		
		} catch (ClosedChannelException e) {
			System.out.println("Ʈ ޼ҵ (ä ݴ  ) : "+e);
		} catch (IOException e) {
			System.out.println("Ʈ ޼ҵ (̿ )"+e);
		}
	}
	
	private void registerChannel(Selector selector, SocketChannel sc, int ops) 
	throws ClosedChannelException,IOException{
		if(sc==null){
			info ("invalid Connection");
			return;
		}
		sc.configureBlocking(false);
		sc.register(selector,ops);
		v.add(sc);
	}
	private void read(SelectionKey key){
		SocketChannel sc = (SocketChannel)key.channel();
		ByteBuffer buffer = ByteBuffer.allocateDirect(1024);
		int read = 0;
		try {
			read = sc.read(buffer);
			
			System.out.println();
			//info(buffer);
			
		} catch (Exception e) {
			System.out.println("read޼ҵ  : "+e);
			try {
				sc.close();
			} catch (Exception e1) {
				System.out.println("read޼ҵ ü Ŭ  : "+e1);
			}
		}
	}
	
	private void info(String str){
		System.out.println(str);
	}
	
	public GroupServer(){
		initServer();
		startServer();
	}
	
	public static void main(String[] args) {
		new GroupServer();
	}
}
