package com.Exception.server;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;
import java.util.logging.FileHandler;
import java.util.logging.Level;
import java.util.logging.Logger;

import com.Exception.GUIKey.ProtocolKey;
import org.eclipse.swt.widgets.Display;
import com.Exception.GUI.*;
import com.Exception.GUIKey.*;
import java.io.*;

public class Server {
	private ServerSocket ss = null;
	//private static FileHandler fileHandler;
	//private static Logger logger = Logger.getLogger("c:\\error\\");
	
	private ContentComposite cc = null;
	private Display display;
	public Server(ContentComposite cc,Display display){
		this.cc= cc;
		this.display = display;
	}
	public Server(){
		run();
	}
	
	public void run() {
		try {
			
			ss = new ServerSocket(10001);
			System.out.println("  !!!");
			HashMap hm = new HashMap();
			
			while(true){
				Socket sock = ss.accept();
				ServerThread st = new ServerThread(sock,hm);
				st.start();
			}
		} catch (Exception e) {
			System.out.println("     : "+e);
			
		}
	}
	
	public static void main(String[] args) {
		new Server();
	}
	class ServerThread extends Thread{
		private Socket sock;
		private HashMap hm;
		private ObjectInputStream ois;
		private ObjectOutputStream oos;
		private MemElement me = new MemElement();
		private ServerManager manager =null;
		
		public ServerThread(Socket sock,HashMap hm){
			this.sock = sock;
			this.hm = hm;
			
		}
		
		public void run(){
			System.out.println("   ok!!!");
			int i=0;
			int j=0;
			try{
				ois = new ObjectInputStream(sock.getInputStream());
				oos = new ObjectOutputStream(sock.getOutputStream());
				while(true){
					System.out.println(j+" Ŭ  !!!");
					Vector v = readVector(ois);
					System.out.println("Server run method vector  : "+v);
					
					i=returnVectorSetting(v);
					if(i==ProtocolKey.logoutOk||i==ProtocolKey.out||i==ProtocolKey.noId||i==ProtocolKey.nopw){
						System.out.println("α׾ƿ  ,   ƿ");
						break;
					}
					System.out.println(j+ " Ŭ  !!!");
					j++;
					
				}
			
			}catch (Exception e) {
				System.out.println(" ͼ!!!!"+e);
				//log(Level.WARNING,"ServerThread run() : ",e);
				if(ois!=null){
					try {
						ois.close();
					} catch (Exception e1) {
						System.out.println("ǲ Ʈ  ݴ  ߻ ͼ : "+e1);
						//log(Level.WARNING,"ServerThread run() ǲ Ʈ  ݴ  ߻ ͼ : ",e);
					}
				}
				if(oos!=null){
					try {
						oos.close();
					} catch (Exception e1) {
						System.out.println(" ƿǲ Ʈ ݴ  ߻ ͼ : "+e1);
						//log(Level.WARNING,"ServerThread run() ƿǲ Ʈ ݴ  ߻ ͼ : ",e);
					}
				}
				if(sock!=null){
					try {
						synchronized (hm) {
							if(!hm.isEmpty()){
								if(me.getEmp_id()!=null){
									hm.remove(me.getEmp_id());
								}
							}
						}
						sock.close();
					} catch (Exception e1) {
						System.out.println(" ݴ  ߻ ͼ : "+e1);
						//log(Level.WARNING,"ServerThread run()  ݴ  ߻ ͼ : ",e);
					}
				}
			}
		}
		
		//͸ о  ù°  Ű  ϴ   
		public Vector readVector(ObjectInputStream ois) throws Exception{
			manager = new ServerManager();
			Vector returnV = new Vector();//return Vector
				System.out.println("ok!!!");
				Vector receiveV =null;
				Object obj = ois.readObject();
				if (obj instanceof Vector) {
					System.out.println("instance of Vector ok!!! ");
					System.out.println("ois : "+ois);
					receiveV = (Vector)obj;//recieve Vector
				int i = ((Integer)receiveV.get(0)).intValue();
				System.out.println(i);
				switch (i) {
				case ProtocolKey.login:
					System.out.println("α !!!"+this);
					me.setEmp_id((String)receiveV.get(1));
					me.setEmp_pw((String)receiveV.get(2));
					synchronized (hm) {
						if(hm.get(me.getEmp_id())!=null){
							returnV.add(new Integer(ProtocolKey.idExist));
							returnV.add(oos);
							System.out.println("̵ üũ 罺!");
							break;
						}
					}
					System.out.println("̵ üũ !");
					me = manager.login(me);
					returnV.add(new Integer(me.getKey()));
					break;
					
				case ProtocolKey.logout:
					System.out.println("α׾ƿ !!!"+this);
					synchronized (hm) {
						hm.remove((String)receiveV.get(1));
						Collection c = hm.keySet();
						Iterator it = c.iterator();
						while(it.hasNext()){
							System.out.println("α׾ƿ α  "+it.next());
						}
					}
					
					returnV.add(new Integer(ProtocolKey.logoutOk));
					break;
					
				case ProtocolKey.out:
					System.out.println("ϱ !!!!"+this);
					me.setEmp_id((String)receiveV.get(1));
					me = manager.exit(me);
					returnV.add(new Integer(me.getKey()));
					break;
					
				case ProtocolKey.seatOut:
					System.out.println("ڸٿ !!!"+this);
						
					break;
					
				case ProtocolKey.newDoc:
					System.out.println(" ۼ!!!"+this);
					
					break;
					
				case ProtocolKey.cateChoice:
					System.out.println("īװ !!!"+this);
					
					break;
					
				case ProtocolKey.apprDoc:
					System.out.println("繮  !!!"+this);
					
					break;
				
				case ProtocolKey.schSel:
					System.out.println("  !!!"+this);
					returnV.add(new Integer(ProtocolKey.re_schSel));
					returnV.add(receiveV.get(1));
					returnV.add(manager.schedule(receiveV));
					break;
					
				case ProtocolKey.schSave:
					System.out.println("  !!!"+this);
					manager.scheduleSave(receiveV);
					returnV.add(new Integer(ProtocolKey.re_schSave));
					returnV.add(receiveV.get(1));
					break;
				case ProtocolKey.searPerson:
					System.out.println(" ˻ !!!"+this);
					
					break;
					
				case ProtocolKey.noteSend:
					System.out.println("  !!!"+this);
					//ڸ  Ե    ִ.
					// Ϳ Ű ؾѴ.
					returnV.add(new Integer(ProtocolKey.re_noteSend));
					returnV.add(receiveV.get(2));
					returnV.add(receiveV.get(1));
					returnV.add(receiveV.get(3));
					break;
					
				case ProtocolKey.noteSaveSend:
					System.out.println(" ϸ鼭  !!!"+ this);
					manager.note(receiveV);
					// Ϳ Ű ؾѴ.
					returnV.add(new Integer(ProtocolKey.re_noteSend));
					returnV.add(receiveV.get(2));
					returnV.add(receiveV.get(1));
					returnV.add(receiveV.get(3));
					returnV.add(manager.note(receiveV));
					break;
				
				case ProtocolKey.noteDel:
					System.out.println(" ");
					manager.noteDel(receiveV);
					returnV.add(new Integer(ProtocolKey.re_noteDel));
					returnV.add(receiveV.get(1));
					sendMessage(returnV);
					break;
				
				case ProtocolKey.noteMove:
					System.out.println(" ̵");
					manager.noteMove(receiveV);
					returnV.add(new Integer(ProtocolKey.re_noteMove));
					break;
					
				case ProtocolKey.noteOk:
					System.out.println(" Ȯ ");
					manager.noteOk(receiveV);
					break;
					
				case ProtocolKey.mailSend:
					System.out.println("  !!!"+this);
					switch (manager.mailSend(receiveV)) {
					case 0:
						//ok
						break;

					case 1:
						//巹 
						break;
						
					case 2:
						//  
						break;
						
					}
					break;
				case ProtocolKey.fileSend:
					System.out.println(" !!!"+this);
					returnV.add(new Integer(617));
					returnV.add(receiveV.get(2));
					returnV.add(receiveV.get(1));
					returnV.add(receiveV.get(3));
					returnV.add(receiveV.get(4));
					break;
					
				case ProtocolKey.docBox:
					System.out.println("  û!!!"+this);
					
					break;
					
				case ProtocolKey.noteBox:
					System.out.println("  û!!!"+this);
					returnV.add(new Integer(ProtocolKey.re_noteBox));
					returnV.add(receiveV.get(1));
					returnV.add(manager.noteBox(receiveV));
					break;
					
				case ProtocolKey.mailBox:
					System.out.println("  û !!!"+this);
					
				case ProtocolKey.notice:
					System.out.println(" 䱸!!!");
					returnV.add(new Integer(ProtocolKey.re_notice));
					returnV.add(receiveV.get(1));
					returnV.add(manager.notice());
					
					break;
					
				case ProtocolKey.config:
					System.out.println(" !!!"+this);
					break;
					
				}
				
				System.out.println("return key : "+me.getKey());
				
			}else{
				returnV.add(new Integer(999));	
				System.out.println("instance of Vector fail!!! ");
			}
			
				return returnV;
			
		}
		
		//    
		public int returnVectorSetting(Vector v) throws IOException{
			int i = ((Integer)v.get(0)).intValue();
			//α׾ƿ̳ ̸  
			System.out.println("  1° Ű : "+i);
			
			switch(i){
				case ProtocolKey.loginOk:
					synchronized (hm) {
						hm.put(me.getEmp_id(),oos);
					}
					v.add(me);
					v.add(manager.allDivision());
					v.add(manager.allUser());
					broadCast(v);
					break;
					
				case ProtocolKey.logoutOk:
					broadCast(v);
					break;
				
				case ProtocolKey.idExist:
					oos= (ObjectOutputStream)v.get(1);
					v.clear();
					v.add(new Integer(ProtocolKey.idExist));
					oos.writeObject(v);
					oos.flush();
					break;
					
				case ProtocolKey.outOk:
					broadCast(v);
					break;

				case ProtocolKey.re_noteSend:
					sendMessage(v);
					break;
					
				case ProtocolKey.re_noteBox:
					sendMessage(v);
					break;
					
				case ProtocolKey.re_fileSend:
					sendMessage(v);
					break;
					
				case ProtocolKey.re_schSel:
					sendMessage(v);
					break;
					
				case ProtocolKey.re_notice:
					sendMessage(v);
					break;
				
				case ProtocolKey.re_schSave:
					sendMessage(v);
					break;
					
				default :
					
					break;
			}
			return i;
		}
		
		
		//ü Ʈ 
		public void broadCast(Vector v) throws IOException{
			synchronized (hm) {
				
				Collection col = hm.values();
				Collection col2 = hm.keySet();
				
				Iterator it = col.iterator();
				Iterator it2 = col2.iterator();
				Vector idList = new Vector();
				
				while(it2.hasNext()){
					idList.add((String)it2.next());
				}
				v.add(idList);
				if(((Integer)v.get(0)).intValue()==ProtocolKey.loginOk){
					v.add(manager.init(me.getEmp_id()));
					v.add(manager.notice());
					System.out.println("α  : "+ v);
				}
				System.out.println("broad cast Vector velue : "+v);
				while(it.hasNext()){
					System.out.println("broad cast while");
					ObjectOutputStream oos = (ObjectOutputStream)it.next();
					System.out.println("broadcast ȯ ");
					oos.writeObject(v);
					oos.flush();
					System.out.println("broadcast ȯ 222222222222222222222");
				}
			}
		}
		
		// 
		public void sendMessage(Vector v) throws IOException{
			synchronized (hm) {
				ObjectOutputStream oos = (ObjectOutputStream)hm.get((String)v.get(1));
				oos.writeObject(v);
				oos.flush();
			}
		}
		
	/*	public void initLog(){
			try {
				fileHandler = new FileHandler("GroupwareServer.log");
			} catch (IOException e) {
				logger.addHandler(fileHandler);
				logger.setLevel(Level.ALL);
			}
		}
		
		public void log(Level level, String msg, Throwable error){
			logger.log(level, msg, error);
		}
		
		public void info(String msg){
			logger.info(msg);
		}*/
	}
}
