package com.itbc.lucene;

import java.io.Reader;

import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.TokenStream;
import org.apache.lucene.analysis.WhitespaceTokenizer;


public class KoreanAnalyzer extends Analyzer {
	private String root="";//α׷ root 
	public KoreanAnalyzer(){}
	
	public KoreanAnalyzer(String root){
		this.root = root;
	}
	public TokenStream tokenStream( String fieldName, Reader content ) {
		return new KoreanStemFilter( new WhitespaceTokenizer( content ),root );
	}
}
