package com.itbc.manager;

import com.itbc.dbCon.DbConnection;
import com.itbc.util.EncryptString;
import com.itbc.util.TimeDate;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.*;

import javax.naming.spi.DirStateFactory.Result;
public class CommuteManager {
	TimeDate td = null;
	Vector v = null;
	public Vector getToday(){
		td = new TimeDate();
		v = new Vector();
		String[] day = td.today().split("-");
		for(int i = 0; i < day.length;i++){
			v.addElement(day[i]);
		}
		return v;
	}
	public String getToday(Vector v){
		
		this.v = v;
		String day=null;
		int len = v.size();
		
		for(int i = 0; i < len;i++){
			if(i==(len-1)){
				day=day+v.get(i);
			}else if(i==0){
				day=v.get(i)+"-";
			}else{
				day=day+v.get(i)+"-";
			}				
			System.out.println(day);
		}
		System.out.println("today ======"+day);
		return day;
	}
	public Vector getRealTime(){
		td = new TimeDate();
		v = new Vector();
		String[] time = td.now().split(":");
		for(int i = 0; i < time.length;i++){
			v.addElement(time[i]);
		}
		return v;
	}
	public String getMode(int seq, String day){
		DbConnection dbcon = new DbConnection();
		EncryptString enStr = new EncryptString();
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		String query = null;
		String mode = null;
		System.out.println(seq);
		System.out.println(day);
		query = "select * from commute where com_seq=? and com_date=?";
		try{
			con = dbcon.getConnection();
			pstmt = con.prepareStatement(query);
			pstmt.setInt(1, seq);
			pstmt.setString(2, day);
			rs = pstmt.executeQuery();
			if(rs.next()){
				mode="comUp";
			}else{
				mode="comNo";
			}
			System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!"+mode);
		}catch(Exception e){
			System.out.println("getMode error : "+e.toString());
		}
		finally{
			try{
				if(rs!=null)rs.close();
			}catch(Exception e){}
			try{
				if(pstmt!=null)pstmt.close();
			}catch(Exception e){}
			try{
				if(con!=null)con.close();
			}catch(Exception e){}
		}	
		return mode;
	}
	public int insCom(int seq, String day, String time){
		DbConnection dbcon = new DbConnection();
		Connection con = null;
		PreparedStatement pstmt = null;
		int a = 0;
		String query = null;
		
		System.out.println("insCom : "+seq);
		System.out.println("insCom : "+day);
		System.out.println("insCom : "+time);
		query = "UPDATE commute SET com_end=? WHERE com_seq=? and com_date=?";
		try{
			con = dbcon.getConnection();
			pstmt = con.prepareStatement(query);
			pstmt.setString(1, time);
			pstmt.setInt(2, seq);
			pstmt.setString(3, day);
			a = pstmt.executeUpdate();
			
		}catch(Exception e){
			System.out.println("insCom error : "+e.toString());
		}
		finally{
			try{
				if(pstmt!=null)pstmt.close();
			}catch(Exception e){}
			try{
				if(con!=null)con.close();
			}catch(Exception e){}
		}	
		return a;
	}
}
