package com.itbc.manager;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;

import com.itbc.Element.Element;
import com.itbc.Element.PositionElement;
import com.itbc.dbCon.DbConnection;
import com.itbc.util.EncryptString;

public class MemInsManager {
	

	
	
	/**########### public void insEmployee(HttpServletRequest request, Element me)
	*  : com.itbc.dbCon DbConnection.java
	* 
	* control request Element ޾ ȸ  bodyPage
	* request setAttributeѴ.
	* 
	* 2008/09/11 by Exception ġ, 豤
	######################################################################**/
	public void insEmployee(HttpServletRequest request, Element me){
		DbConnection dbcon = new DbConnection();
		EncryptString enStr = new EncryptString();
		Connection con = null;
		PreparedStatement pstmt = null;		
		String query = null;
		String bodyPage=null;
		query = "INSERT INTO employee(emp_seq, emp_name, emp_id," +
				" emp_pw, emp_position, emp_salary," +
				" emp_safe, emp_division) VALUES (?, ?, ?, ?, ?, ?, " +
				"?, ?);";
		try{
			con = dbcon.getConnection();
			pstmt = con.prepareStatement(query);
			pstmt.setInt(1, me.getEmp_seq());
			pstmt.setString(2, me.getEmp_name());
			pstmt.setString(3, me.getEmp_id());
			pstmt.setString(4, enStr.encryptString(me.getEmp_pw()));
			pstmt.setString(5, me.getEmp_position());
			pstmt.setString(6, me.getEmp_salary());
			pstmt.setInt(7, me.getEmp_safe());
			pstmt.setString(8, me.getEmp_division());
			pstmt.executeUpdate();
			bodyPage="/member/insOk.jsp";
			request.setAttribute("bodyPage",bodyPage);
			
		}catch(Exception e){
			bodyPage="/member/insErr.jsp";
			request.setAttribute("bodyPage",bodyPage);
			System.out.println("insEmp error : "+e.toString());
		}
		finally{
			
			try{
				if(pstmt!=null)pstmt.close();
			}catch(Exception e){}
			try{
				if(con!=null)con.close();
			}catch(Exception e){}
		}	
	}
	/**########### public int getMemSeq(int position)########################
	*  : com.itbc.dbCon DbConnection.java
	* 
	* control position ޾ seqذ  DB ˻Ѵ 
	* num Ѱش.
	* 
	* 2008/09/11 by Exception ġ, 豤
	######################################################################**/
	
	public int getMemSeq(int position){
		DbConnection dbcon = new DbConnection();
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		String query = null;
		int num = 0;
		int indexSeq = position ;
		//System.out.println("indexSeq : "+indexSeq);
		int lastSeq = indexSeq+100;
		query = "select max(emp_seq) from employee where emp_seq>? and ?>emp_seq";
		try{
			con = dbcon.getConnection();
			pstmt = con.prepareStatement(query);
			pstmt.setInt(1,indexSeq);
			pstmt.setInt(2,lastSeq);
			rs = pstmt.executeQuery();
			if(rs.next()){
				num=rs.getInt(1);
				//System.out.println("num : "+num);
				if(num!=0){
					//System.out.println("0! ok");
					num = num+1;
				}else{
					//System.out.println("0! no");
					num = indexSeq+1;
				}	
			}
		}catch(Exception e){
			System.out.println("getSeq error : "+e.toString());
		}
		finally{
			try{
				if(rs!=null)rs.close();
			}catch(Exception e){}
			try{
				if(pstmt!=null)pstmt.close();
			}catch(Exception e){}
			try{
				if(con!=null)con.close();
			}catch(Exception e){}
		}	
		
		return num;
	}
	public ArrayList getDivision(){
		System.out.println("getDivision!!!!!!!!!!!");
		DbConnection dbcon = new DbConnection();
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		ArrayList dvList = new ArrayList();
		String query = null;
		String division = null;
		
		query = "select * from division";
		try{
			con = dbcon.getConnection();
			pstmt = con.prepareStatement(query);
			rs = pstmt.executeQuery();
			while(rs.next()){
				division = rs.getString("div_name");
				dvList.add(division);
				System.out.println("division : "+division);
			
			}
		}catch(Exception e){
			System.out.println("getDivision error : "+e.toString());
		}
		finally{
			try{
				if(rs!=null)rs.close();
			}catch(Exception e){}
			try{
				if(pstmt!=null)pstmt.close();
			}catch(Exception e){}
			try{
				if(con!=null)con.close();
			}catch(Exception e){}
		}	
		
		return dvList;
	}
	public ArrayList getPosition(){
		System.out.println("getDivision!!!!!!!!!!!");
		DbConnection dbcon = new DbConnection();
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		ArrayList poList = new ArrayList();
		String query = null;
		PositionElement pElement = null;
		
		query = "select * from position_name";
		try{
			con = dbcon.getConnection();
			pstmt = con.prepareStatement(query);
			rs = pstmt.executeQuery();
			while(rs.next()){
				pElement = new PositionElement(rs.getInt("p_seq"),rs.getString("p_name"));
				System.out.println("p_seq : "+pElement.getP_seq()+" : p_name = "+pElement.getP_name());
				poList.add(pElement);
			}
		}catch(Exception e){
			System.out.println("getPosition error : "+e.toString());
		}
		finally{
			try{
				if(rs!=null)rs.close();
			}catch(Exception e){}
			try{
				if(pstmt!=null)pstmt.close();
			}catch(Exception e){}
			try{
				if(con!=null)con.close();
			}catch(Exception e){}
		}	
		
		return poList;
	}

}
