package com.itbc.servlet;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import com.itbc.util.*;
import com.itbc.control.*;
import com.itbc.lucene.*;


public class MainServlet extends HttpServlet{
	
	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {	
		doProcess(request, response);
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		System.out.println("ok");
		doProcess(request, response);
	}
	
	/**########### private void doProcess(reqeust, response) #################
	*  : Command Command  ControllerŬ
	* 
	* request θ ߶ ڷ Ͽ  ο ´ Controller Ͽ
	* Excete(request, response)  resultPage  Ѿ.
	* 
	* 2008/09/10 by Exception ġ, 豤
	######################################################################**/
	private void doProcess(HttpServletRequest request, HttpServletResponse response)
	throws ServletException, IOException {
		
		String resultPage = null;
		Command cmd = null;
		
		request.setCharacterEncoding("EUC-KR");
		response.setHeader("Cache-control", "no-cache");
		String type = null;
		
		type = request.getRequestURI();
		
		if(type.indexOf(request.getContextPath()) == 0){
			type = type.substring(request.getContextPath().length());
		}
		System.out.println("type : "+type);
		
		
		if(type.equals("/main.do")){
			cmd = new MainControl();
			resultPage = cmd.Execute(request, response);			
		}else if(type.equals("/memIns.do")){
			cmd = new MemInsControl();
			resultPage = cmd.Execute(request, response);
			
		}else if(type.equals("/search.do")){
			System.out.println("search ");
			cmd = new SearchControl();
			resultPage = cmd.Execute(request, response);
			//System.out.println("idchk : "+resultPage);
			//System.out.println("check : "+request.getAttribute("check"));
		}else if(type.equals("/login.do")){
			cmd = new LoginControl();
			resultPage = cmd.Execute(request, response);
			
		}else if(type.equals("/notice.do")){
			System.out.println("notice!!!!");
			cmd = new NoticeControl();
			resultPage = cmd.Execute(request, response);
		}else if(type.equals("/commute.do")){
			System.out.println("/commute.do");
			cmd = new CommuteControl();
			resultPage = cmd.Execute(request, response);
		}else if(type.equals("/lucene.do")){
			System.out.println("/lucene.do");
			LuceneControl lu = new LuceneControl();
			String path = getServletConfig().getServletContext().getRealPath("");//ε  ġ
			request.setAttribute("path",path);
			resultPage = lu.Execute(request, response);
			
		}else if(type.equals("/schedule.do")){
			System.out.println("/schedule.do");
			
			resultPage = "";
			
		}
		
		
		request.getRequestDispatcher(resultPage).forward(request, response);
	}
}
